'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  OpenOffice.org - a multi-platform office productivity suite
'*
'*  $RCSfile: c_106_.inc,v $
'*
'*  $Revision: 1.23 $
'*
'*  last change: $Author: jsi $ $Date: 2007/10/11 12:41:52 $
'*
'*  The Contents of this file are made available subject to
'*  the terms of GNU Lesser General Public License Version 2.1.
'*
'*
'*    GNU Lesser General Public License Version 2.1
'*    =============================================
'*    Copyright 2005 by Sun Microsystems, Inc.
'*    901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*    This library is free software; you can redistribute it and/or
'*    modify it under the terms of the GNU Lesser General Public
'*    License version 2.1, as published by the Free Software Foundation.
'*
'*    This library is distributed in the hope that it will be useful,
'*    but WITHOUT ANY WARRANTY; without even the implied warranty of
'*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*    Lesser General Public License for more details.
'*
'*    You should have received a copy of the GNU Lesser General Public
'*    License along with this library; if not, write to the Free Software
'*    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*    MA  02111-1307  USA
'*
'/************************************************************************
'*
'* owner : joerg.sievers@sun.com
'*
'* short description : Detailed test of Calc features in menu Tools
'*
'************************************************************************
'*
' #1 C_106_ ' Initial routine
' #1 tToolsThesaurus
' #1 tToolsAutocorrection
' #1 tToolsGoalSeek
' #1 tToolsScenarios
' #1 tToolsProtectSheet
' #1 tToolsAutomaticCalculate
' #1 tToolsRecalculate
' #1 tToolsAutoInput
'*
'\***********************************************************************

sub C_106_
Printlog "--------- C_106_ ---------"
     
   Call tToolsThesaurus
   Call tToolsAutocorrection
   Call tToolsGoalSeek
   Call tToolsScenarios
   Call tToolsProtectSheet
   Call tToolsAutomaticCalculate
   Call tToolsRecalculate
   Call tToolsAutoInput
end sub
'
'-----------------------------------------------------
'
testcase tToolsThesaurus
'/// This test checks, if there appears any suggestion for an inserted word in a document.

    dim merksdir$,merksdir2$
    if gOOo then
       qaErrorLog "Feature not supported in OpenOffice.org"
       goto endsub
    endif

    select case iSystemSprache
        case 01   : merksdir$ = "example"
        case 31   : merksdir$ = "test"
        case 33   : merksdir$ = "test"
        case 34   : merksdir$ = "ensayo"
        case 39   : merksdir$ = "test"
        case 45   : merksdir$ = "sum"
        case 49   : merksdir$ = "Experiment"
        case 46   : merksdir$ = "Experiment"        
        case 03, 07, 30, 35, 36, 37, 42, 47, 48, 51, 55, 81, 82, 86, 88, 90 :
                    printlog "For this system language (" & iSystemSprache & ") no thesaurus is available" 
                    goto endsub
        case else : QAErrorlog "language adjustment for system language " & iSystemSprache & " doesn't exist." 
                    goto endsub
    end select

    Call hNewDocument

    DocumentCalc.TypeKeys merksdir$ & "<Return><Up>"
    try
       ToolsLanguageThesaurusCalc
    catch
       warnlog "Thesaurus menu item seems to be inactive."
       goto endsub
    endcatch

    Kontext "Thesaurus"
    if Thesaurus.exists then
       if Synonym.getItemCount > 0 then
          Synonym.select 1
          if Ersetzen.GetText <> "" then
              printlog "OK"
          else
              warnlog "Thesaurus has no suggestion"
          end if
       else 
           warnlog "Empty list - maybe wrong language settings - please verify"
       endif
       Thesaurus.Ok
    else
        Warnlog "Thesaurus did not appeared"
    end if
    Call hCloseDocument

endcase
'
'-----------------------------------------------------
'
testcase tToolsAutocorrection
'/// This test checks, if the autocorrection appears when a false word is
'/// inserted into a document

    dim wh as integer
    dim merksdir$,merksdir2$

        select case iSystemSprache
        ' The second parameter isn't used at this time
        case 01   : merksdir$ = "reccommend" : merksdir2$ = "Recommend"
        case 03   : merksdir$ = "aer"        : merksdir2$ = "era"
        case 31   : merksdir$ = "abcent"     : merksdir2$ = "absent"
        case 33   : merksdir$ = "problemme" : merksdir2$ = "problème"
        case 34   : merksdir$ = "Poblema" : merksdir2$ = "Problema"
        case 39   : merksdir$ = "inportante" : merksdir2$ = "importante"
        case 45   : merksdir$ = "addresse" : merksdir2$ = "adresse"
        case 46   : merksdir$ = "CHFE" : merksdir2$ = "chef"        
        case 49   : merksdir$ = "GECHICHTE" : merksdir2$ = "Geschichte"        
        case >80  : QAErrorLog "There is no autocorrection available for asian languages"
                                goto endsub
        case else : QAErrorlog "There is no language adjustment for language: " & iSystemSprache
                    goto endsub
    end select

    Call hNewDocument
    Kontext "DocumentCalc"
    DocumentCalc.TypeKeys "<Mod1 Home>"
    ToolsAutocorrect
    try
        Kontext
        if Active.exists(1) then
            warnlog Active.GetText
            Active.OK                
        end if
    catch
    endcatch
    Kontext
    Active.SetPage TabOptionen
    Kontext "TabOptionen"
    try
        if Einstellungen.getseltext = "Ersetzungstabelle anwenden" then
            printlog " Replacement table apply found"
        end if
    catch
        printlog " Treelistbox don't work (isn't still yet available!)"
    endcatch    
    try
        Kontext "TabOptionen"
        TabOptionen.Ok
    catch
        Kontext "TabAusnahmen"
        TabAusnahmen.OK
        warnlog "Tabpage Exceptions was activated"
    endcatch
    try
        Kontext
        if Active.Exists(1) then
            printlog Active.GetText
            Active.OK
            Kontext "TabOptionenAutokorrektur"
            TabOptionenAutokorrektur.Ok
        end if
    catch
    endcatch
    Kontext "DocumentCalc"
    DocumentCalc.TypeKeys merksdir$ & "<Return><Up>"
    if czellinhalt("A1") <> merksdir$ then
        printlog "OK, the word has been replaced"
    else
        warnlog "It seems that the auto-correction doesn't work"
    end if    
    Call hCloseDocument
endcase
'
'-----------------------------------------------------------
'
testcase tToolsGoalSeek
'/// In this test two values are inserted into two cells. Then in the next cell a sum formula
'/// calculates the sum from this cells. Now the menu ToolsGoalSeek is called and the goal and
'/// the variable cell is set. Then this dialog is closed with OK, and it is checked, if the
'/// result of the variable cell has been correct calculated.

    dim merksdir$,merksdir2$

    select case iSprache
        case 01   : merksdir$ = "1<Return>2<Return>=Sum(A1:A2)<Return>"
        case 03   : merksdir$ = "1<Return>2<Return>=SOMA(A1:A2)<Return>"
        case 07   : merksdir$ = "1<Return>2<Return>=Sum(A1:A2)<Return>"
        case 31   : merksdir$ = "1<Return>2<Return>=SOM(A1:A2)<Return>"
        case 33   : merksdir$ = "1<Return>2<Return>=Somme(A1:A2)<Return>"
        case 34   : merksdir$ = "1<Return>2<Return>=Suma(A1:A2)<Return>"
        case 39   : merksdir$ = "1<Return>2<Return>=Somma(A1:A2)<Return>"
        case 45   : merksdir$ = "1<Return>2<Return>=Sum(A1:A2)<Return>"
        case 46   : merksdir$ = "1<Return>2<Return>=Summa(A1:A2)<Return>"
        case 48   : merksdir$ = "1<Return>2<Return>=Suma(A1:A2)<Return>"
        case 49   : merksdir$ = "1<Return>2<Return>=Summe(A1:A2)<Return>"
        case 55   : merksdir$ = "1<Return>2<Return>=Soma(A1:A2)<Return>"
        case >80  : merksdir$ = "1<Return>2<Return>=Sum(A1:A2)<Return>"
        case else : QAErrorlog "Still missing the language adjustment!" : goto endsub
    end select
    
    Call hNewDocument

        DocumentCalc.TypeKeys merksdir$
        ToolsGoalSeek
        Sleep 3
        Kontext "Zielwertsuche"
        Formelzelle.SetText "$A$3"
        Zielwert.SetText "13"
        VariableZelle.SetText "$A$2"
        Zielwertsuche.Ok
        Sleep 2
        Kontext "Active"
        Active.Yes
        Kontext
        DocumentCalc.TypeKeys "<Up><Up>"
        EditCopy
        call cClipboardVergleichen "12"

    Call hCloseDocument

endcase
'
'------------------------------------------------------------
'
testcase tToolsScenarios
'/// This test if a scenario is created. ///

    dim merksdir$,merksdir2$

    select case iSprache
        case 01   : merksdir$ = "Sheet1_Scenario_1"
        'case 03   : merksdir$ = "Folha1_CenÃ¡rio_1"
        case 31   : merksdir$ = "Werkblad1_Scenario_1"
        case 33   : merksdir$ = "Feuille1_Scénario_1"
        case 34   : merksdir$ = "Hoja1_Escenario_1"
        case 39   : merksdir$ = "Tabella1_Scenario_1"
        'case 45   : merksdir$ = "Ark1_Scenarie_1"
        case 46   : merksdir$ = "Tabell1_Scenario_1"
        'case 48   : merksdir$ = "Arkusz1_Scenariusz_1"
        case 49   : merksdir$ = "Tabelle1_Szenario_1"
        case 55   : merksdir$ = "Planilha1_Cenário_1"
        case >80  : merksdir$ =  ""                                             'The scenarioname is evaluate later
        case else : merksdir$ = "Tabelle1_Szenario_1" : QAErrorLog "No Big Ten language - No test" : goto endsub
    end select

    Call hNewDocument

        DocumentCalc.Typekeys "1<Return>2<Return><Up><Shift Up>"
        ToolsScenarios
        Kontext "SzenarioAnlegen"
        GanzeTabelle.check
        SzenarioAnlegen.Ok
        sleep(1)
        if iSprache > 80 then 
            merksdir$ = getSheetName()
        end if
        Kontext "DocumentCalc"
        FormatSheetRename
        Kontext "TabelleUmbenennen"
        if TabellenName.GetText = merksdir$ then
                printlog "OK"
        else
            warnlog "No scenario created"
    end if
    TabelleUmbenennen.Ok

    Call hCloseDocument

endcase
'
'------------------------------------------------------------
'
testcase tToolsProtectSheet
'/// This test checks, if the protection of a sheet works.
'/// After activating the protection, it must be appear a hint, that
'/// protected cells cannot be modified, if you attempt it.

    Call  hNewDocument

        ToolsProtectDocumentSheet
        Kontext "TabelleSchuetzen"
        TabelleSchuetzen.Ok
        Kontext
        DocumentCalc.TypeKeys " "
        if Active.exists (2) then
                Kontext
            Active.Ok
            printlog "OK"
        else
            warnlog "Sheet not protected"
        end if

    Call hCloseDocument

endcase
'
'------------------------------------------------------------
'
testcase tToolsAutomaticCalculate
'/// It is tested, if the automatic calculate works. Insert in cell 'A1' a '1'.
'/// Insert in cell 'A2' a '2'. The sum in cell 'A3' must be '3'. Now
'/// deactivate the automatic calculation and insert in cell 'A2' a '4'.
'/// The result in cell 'A3' must be still a '3'. After reactivating the
'/// automatic calculation

    Call  hNewDocument

        Kontext
        DocumentCalc.TypeKeys "1<Return>2<Return>=A1+A2<Return><Up>"
        EditCopy
        if GetClipboardText = "3" then
                printlog "Switch off automatic calculate"
                ToolsCellContentsAutoCalculate  'switch off
        end if
    Kontext
        DocumentCalc.TypeKeys "<Up><Up>4<Return><Down>"
        EditCopy
        if GetClipboardText = "3" then
                printlog "Switch on automatic calculate"
                ToolsCellContentsAutoCalculate  'switch on
        Kontext
            EditCopy
            if GetClipboardText = "6" then
                printlog "OK, the result is 6"
            else
                warnlog "Automatic Recalculate not switched on"
            end if
        else
                warnlog "Automatic Recalculate not switched off"
        end if

    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tToolsRecalculate
'/// This test checks, if the manuel recalculation works. The automatic
'/// calculation must be switched off at first. Then values are inserted
'/// in cells 'A1' and 'A2'. In cell 'A3' the sum from 'A1' and 'A2' is created.
'/// After modifying the cellcontents of 'A1' and 'A2' the result in cell
'/// 'A3' must be the same. After recalculating manually the result of
'/// cell 'A3' must be updated.

        Call  hNewDocument

        Kontext
        DocumentCalc.TypeKeys "1<Return>2<Return>=A1+A2<Return><Up>"
        EditCopy
        if GetClipboardText = "3" then
                ToolsCellContentsAutoCalculate  'switch off
        end if

        Kontext
        DocumentCalc.TypeKeys "<up><up>2<Return>3<Return>"
        if cZellwert("A3") = "3" then
                printlog "OK, the result is 3"
        else
                warnlog "The autocalculation has not been switched off"
        end if
   ToolsCellContentsRecalculate
        if cZellwert("A3") = "5" then
                printlog "OK, the result is 5 after new calculation"
        else
          warnlog "Result wasn't recalculated automatically"
        end if

        ToolsCellContentsAutoCalculate  'switch on

   Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tToolsAutoInput
'/// This test checks, if the autocompletion works.
'/// A document is opened. Then a string is inerted into the first cell.
'/// In the next cell downwards a character which is the same as the first
'/// character in the string above is inserted and the RETURN button is pressed.
'/// Now it is checked, if the content of the second cell is the same as in
'/// the first cell.
'/// After this, the autocompletion is turned off, and the same procedure
'/// is repeated. Now it is checked if the cellcontent of the second cell is different
'/// to the content of the first cell.

        Call  hNewDocument
        Kontext
        DocumentCalc.TypeKeys "Bla Bla Bla<Return>"
        DocumentCalc.TypeKeys "B<Return><Up>"

        EditCopy
        if GetClipboardText = "Bla Bla Bla" then
                ToolsCellContentsAutoInput      'ausschalten
        end if

        Kontext
        DocumentCalc.TypeKeys "<Right>Bla Bla Bla<Return>"
        DocumentCalc.TypeKeys "B<Return><Up>"
        EditCopy
        if GetClipboardText = "B" then
                ToolsCellContentsAutoInput      'einschalten
            Kontext
                DocumentCalc.TypeKeys "<Right>Bla Bla Bla<Return>"
                DocumentCalc.TypeKeys "B<Return><Up>"
                EditCopy
                if GetClipboardText = "Bla Bla Bla" then
                        Printlog "Ok"
                end if
        else
                Warnlog "AutoInput doesn't work"
        end if

    Call hCloseDocument

endcase

