'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  OpenOffice.org - a multi-platform office productivity suite
'*
'*  $RCSfile: ch2_3dview_perspective.inc,v $
'*
'*  $Revision: 1.2 $
'*
'*  last change: $Author: jsi $ $Date: 2007/05/25 09:59:49 $
'*
'*  The Contents of this file are made available subject to
'*  the terms of GNU Lesser General Public License Version 2.1.
'*
'*
'*    GNU Lesser General Public License Version 2.1
'*    =============================================
'*    Copyright 2005 by Sun Microsystems, Inc.
'*    901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*    This library is free software; you can redistribute it and/or
'*    modify it under the terms of the GNU Lesser General Public
'*    License version 2.1, as published by the Free Software Foundation.
'*
'*    This library is distributed in the hope that it will be useful,
'*    but WITHOUT ANY WARRANTY; without even the implied warranty of
'*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*    Lesser General Public License for more details.
'*
'*    You should have received a copy of the GNU Lesser General Public
'*    License along with this library; if not, write to the Free Software
'*    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*    MA  02111-1307  USA
'*
'/************************************************************************
'*
'* owner : joerg.sievers@sun.com
'*
'* short description : Chart2 - 3D View dialog spec. chapter 4.1
'*
'************************************************************************
'*
' #1 t41AllPerspectiveValuesZero            'chapter 4.1 of specification
' #1 t41PerspectiveDefaults                 'chapter 4.1 of specification
' #1 t41PerspectiveBoundaryValueAnalysis    'chapter 4.1 of specification
' #1 t41PerspectiveDonutDefaults            'chapter 4.1 of specification
'*
'\************************************************************************

testcase t41AllPerspectiveValuesZero
'/// Load simple 3D chart test document (../chart2/update/input/3d_simple_chart.ods)
'/// Activate first and onliest OLE (the 3D chart) in the document via Navigator
'/// Edit / Object / Edit
'/// Open 3D View dialog via Format / 3D View
'/// Switch to tab page <i>Perspective</i>
'/// Set the values of <i>X rotation</i>, <i>Y rotation</i> and <i>Z rotation</i> to 0
'/// Disable the <i>Perspective</i> check-box
'/// Save the file as ($WORKDIR/3d_simple_chart_zero.ods)
'/// File / Close the document
'/// Load the saved document ($WORKDIR/3d_simple_chart_zero.ods)
'/// Activate first and onliest OLE (the 3D chart) in the document via Navigator
'/// Edit / Object / Edit
'/// Open 3D View dialog via Format / 3D View
'/// Switch to tab page <i>Perspective</i>
'/// The test case is passed if the values of <i>X rotation</i>, <i>Y rotation</i> and <i>Z rotation</i> are 0
endcase
'
'-------------------------------------------------------------------------------
'
testcase t41PerspectiveDefaults
'/// Load simple 3D chart test document (../chart2/update/input/3d_simple_chart.ods)
'/// Activate first and onliest OLE (the 3D chart) in the document via Navigator [RETURN]
'/// Close the Navigator
'/// Press [DEL] to remove the chart
'/// Press [STRG+HOME]
'/// [I]nsert / Ch[a]rt
'/// After the Chart wizard appeared...
'/// Check <i>3D Look</i> check-box and press <i>FINISH</i> button of the wizard
'/// Open 3D View dialog via Format / 3D View
'/// Switch to tab page <i>Perspective</i>
'/// The test case is passed if the the vakue of 
'///+<ul><li><i>X rotation</i> = 11 degrees</li>
'///+<li><i>Y rotation</i> = 25 degrees</li>
'///+<li><i>Z rotation</i> = 5 degrees</li>
'///+<li><i>Perspective</i> check-box is checked</li>
'///+<li>Perspective <i>value</i> = 20%</li></ul>
'/// Leave the <i>3D View</i> dialog with [Cancel]
'/// Close the document and ignore the changes
endcase
'
'-------------------------------------------------------------------------------
'
testcase t41PerspectiveBoundaryValueAnalysis 
'/// Load simple 3D chart test document (../chart2/update/input/3d_simple_chart.ods)
'/// Activate first and onliest OLE (the 3D chart) in the document via Navigator
'/// Edit / Object / Edit
'/// Open 3D View dialog via Format / 3D View
'/// Switch to tab page <i>Perspective</i>
'/// Enter the values
'///+ <ul>li><i>X rotation</i> = -180</li>
'///+ <li><i>Y rotation</i> = 180</li>
'///+ <li><i>Z rotation</i> = 100</li></ul> 
'/// Press <b>OK</b> button
'/// Open 3D View dialog via Format / 3D View
'/// Switch to tab page <i>Perspective</i>
'/// Validate the values
'///+ <ul>li><i>X rotation</i> = 0</li>
'///+ <li><i>Y rotation</i> = 0</li>
'///+ <li><i>Z rotation</i> = -80</li></ul> 
'///+ <ul><li><u>Note</u>: <i>The result is confusing but the data is being stored in
'///+ a matrix and there is not only one way back to the data -> see: i76711</i></li></ul>
'/// Leave the <i>3D View</i> dialog with [Cancel]
'/// Close the document and ignore the changes
endcase
'
'-------------------------------------------------------------------------------
'
testcase t41PerspectiveDonutDefaults
'/// Load simple 3D chart test document (../chart2/update/input/3d_simple_chart.ods)
'/// Activate first and onliest OLE (the 3D chart) in the document via Navigator [RETURN]
'/// Close the Navigator
'/// Press [DEL] to remove the chart
'/// Press [STRG+HOME]
'/// [I]nsert / Ch[a]rt
'/// After the Chart wizard appeared...
'/// Select the third entry from the top (Pie)
'/// Select the third from the left in that group (Donut)
'/// Check <i>3D Look</i> check-box and press <i>FINISH</i> button of the wizard
'/// Open 3D View dialog via Format / 3D View
'/// Switch to tab page <i>Perspective</i>
'/// The test case is passed if the the vakue of 
'///+<ul><li><i>X rotation</i> = -60 degrees</li>
'///+<li><i>Y rotation</i> = 0 degrees</li>
'///+<li><i>Z rotation</i> = 0 degrees</li>
'///+<li><i>Perspective</i> check-box is checked</li>
'///+<li>Perspective <i>value</i> = 5%</li></ul>
'/// Leave the <i>3D View</i> dialog with [Cancel]
'/// Close the document and ignore the changes
endcase

