'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  OpenOffice.org - a multi-platform office productivity suite
'*
'*  $RCSfile: ch2_insert.inc,v $
'*
'*  $Revision: 1.4 $
'*
'*  last change: $Author: jsi $ $Date: 2007/06/13 14:11:58 $
'*
'*  The Contents of this file are made available subject to
'*  the terms of GNU Lesser General Public License Version 2.1.
'*
'*
'*    GNU Lesser General Public License Version 2.1
'*    =============================================
'*    Copyright 2005 by Sun Microsystems, Inc.
'*    901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*    This library is free software; you can redistribute it and/or
'*    modify it under the terms of the GNU Lesser General Public
'*    License version 2.1, as published by the Free Software Foundation.
'*
'*    This library is distributed in the hope that it will be useful,
'*    but WITHOUT ANY WARRANTY; without even the implied warranty of
'*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*    Lesser General Public License for more details.
'*
'*    You should have received a copy of the GNU Lesser General Public
'*    License along with this library; if not, write to the Free Software
'*    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*    MA  02111-1307  USA
'*
'/************************************************************************
'*
'* owner : joerg.sievers@sun.com
'*
'* short description : Chart resource test - Menu INSERT
'*
'************************************************************************
'*
' #1 tInsertTitle
' #1 tInsertAxes
' #1 tInsertGrids
' #1 tInsertLegend
' #1 tInsertDataLabels
' #1 tInsertStatistics
' #1 tInsertSpecialCharacter
'*
'\************************************************************************

testcase tInsertTitle
'///<u><b>Dialog test after invoking Insert::Title</b></u>

'///<ul>
   '///+<li>Load simple chart document</li>
   if fLoadVerySimpleChartAndSaveLocal() > 0 then
       warnlog "Loading test document seems to have failed -> Check this out!"
       goto endsub
   endif
   '///+<li>Select chart using navigator</li>
   call fSelectFirstOLE
   '///+<li>Invoke Edit::Object::Edit to enter Inplace Mode</li>
   EditObjectEdit
   '///+<li>Convert chart to 3D (this will enable all controls in Titles dialog)</li>
   if NOT fConvertChartTo3D() then
       warnlog "Conversion of chart to 3D failed -> Quit testcase"
       Call hCloseDocument
       goto endsub
   endif
   '///+<li>Invoke Insert::Titles</li>
   if fInvokeTitlesDialog() > 0 then
       warnlog "Something went wrong trying to invoke Titles dialog -> Check this out! (Previous log may help you)"
       Call hCloseDocument
       goto endsub
   endif
   '///+<li>Check existence of dialog</li>
   Kontext "InsertTitleDialog"
   Call DialogTest ( InsertTitleDialog )
   '///+<li>Quit dialog using Cancel button</li>
   InsertTitleDialog.Cancel
   '///<li>Close document</li>
   Kontext "DocumentCalc"
   DocumentCalc.TypeKeys "<Escape>"
   Call hCloseDocument
'///</ul>

endcase
'-------------------------------------------------------------
testcase tInsertAxes
'///<u><b>Dialog test after invocation of Insert::Axes</b></u>

'///<ul>
   '///+<li>Load simple test document</li>
   if fLoadVerySimpleChartAndSaveLocal() > 0 then
       warnlog "Loading test document seems to have failed -> Check this out!"
       goto endsub
   endif
   '///+<li>Select chart using navigator</li>
   call fSelectFirstOLE
   '///+<li>Invoke Edit::Object::Edit to enter Inplace Mode</li>
   EditObjectEdit
   '///+<li>Invoke Insert::Axes</li>
   if fInvokeAxesDialog() > 0 then
       warnlog "Something went wrong trying to invoke Axes dialog -> Check this out! (Previous log may help you)"
       Call hCloseDocument
       goto endsub
   endif
   '///+<li>Check existence of dialog</li>
   Kontext "InsertAxesDialog"
   Call DialogTest ( InsertAxesDialog )
   '///+<li>Quit dialog using Cancel button</li>
   InsertAxesDialog.Cancel
   Kontext "DocumentCalc"
   DocumentCalc.TypeKeys "<Escape>"
   '///<li>Close document</li>///
   Call hCloseDocument
'///</ul>

endcase
'-------------------------------------------------------------
testcase tInsertGrids
'///<u><b>Dialog test after invocation of Insert::Grids</b></u>

'///<ul>
   '///+<li>Load simple test document</li>
   if fLoadVerySimpleChartAndSaveLocal() > 0 then
       warnlog "Loading test document seems to have failed -> Check this out!"
       goto endsub
   endif
   '///+<li>Select chart using navigator</li>
   call fSelectFirstOLE
   '///+<li>Invoke Edit::Object::Edit to enter Inplace Mode</li>
   EditObjectEdit
   '///+<li>Invoke Insert::Grids</li>
   if fInvokeGridsDialog() > 0 then
       warnlog "Something went wrong trying to invoke Grids dialog -> Check this out! (Previous log may help you)"
       Call hCloseDocument
       goto endsub
   endif
   '///+<li>Check existence of dialog</li>
   Kontext "InsertGridsDialog"
   Call DialogTest ( InsertGridsDialog )
   '///+<li>Quit dialog using Cancel button</li>
   InsertGridsDialog.Cancel
   Kontext "DocumentCalc"
   DocumentCalc.TypeKeys "<Escape>"
   '///<li>Close document</li>///
   Call hCloseDocument

endcase
'-------------------------------------------------------------
testcase tInsertLegend
'///<u><b>Dialog test after invocation of Insert::Legend</b></u>

'///<ul>
   '///+<li>Load simple test document</li>
   if fLoadVerySimpleChartAndSaveLocal() > 0 then
       warnlog "Loading test document seems to have failed -> Check this out!"
       goto endsub
   endif
   '///+<li>Select chart using navigator</li>
   call fSelectFirstOLE
   '///+<li>Invoke Edit::Object::Edit to enter Inplace Mode</li>
   EditObjectEdit
   '///+<li>Invoke Insert::Legend</li>
   if fInvokeLegendDialog() > 0 then
       warnlog "Something went wrong trying to invoke Legend dialog -> Check this out! (Previous log may help you)"
       Call hCloseDocument
       goto endsub
   endif
   '///+<li>Check existence of dialog</li>
   Kontext "InsertLegendDialog"
   Call DialogTest ( InsertLegendDialog )
   '///+<li>Quit dialog using Cancel button</li>
   InsertLegendDialog.Cancel
   Kontext "DocumentCalc"
   DocumentCalc.TypeKeys "<Escape>"
   '///<li>Close document</li>///
   Call hCloseDocument

endcase
'-------------------------------------------------------------
testcase tInsertDataLabels
'///<u><b>Dialog test after invocation of Insert::Data Labels</b></u>

'///<ul>
   '///+<li>Load simple test document</li>
   if fLoadVerySimpleChartAndSaveLocal() > 0 then
       warnlog "Loading test document seems to have failed -> Check this out!"
       goto endsub
   endif
   '///+<li>Select chart using navigator</li>
   call fSelectFirstOLE
   '///+<li>Invoke Edit::Object::Edit to enter Inplace Mode</li>
   EditObjectEdit
   '///+<li>Invoke Insert::Data Labels</li>
   if fInvokeDataLabelsDialog() > 0 then
       warnlog "Something went wrong trying to invoke Labels dialog -> Check this out!"
       Call hCloseDocument
       goto endsub
   endif
   '///+<li>Check 'Show Value' to enable all controls</li>
   Kontext "InsertLabelsDialog"
   if fSetShowValue ( TRUE ) > 0 then
       warnlog "Something went wrong trying to check 'Show Value' -> Check this out!"
   endif
   '///+<li>Check existence of dialog</li>
   Call DialogTest ( InsertLabelsDialog )
   '///+<li>Quit dialog using Cancel button</li>
   InsertLabelsDialog.Cancel
   Kontext "DocumentCalc"
   DocumentCalc.TypeKeys "<Escape>"
   '///<li>Close document</li>///
   Call hCloseDocument

endcase

'-------------------------------------------------------------
testcase tInsertStatistics
'///<u><b>Dialog test after invocation of Insert::Statistics</b></u>

'///<ul>
   '///+<li>Load simple test document</li>
   if fLoadVerySimpleChartAndSaveLocal() > 0 then
       warnlog "Loading test document seems to have failed -> Check this out!"
       goto endsub
   endif
   '///+<li>Select chart using navigator</li>
   call fSelectFirstOLE
   '///+<li>Invoke Edit::Object::Edit to enter Inplace Mode</li>
   EditObjectEdit
   '///+<li>Invoke Insert::Statistics</li>
   if fInvokeStatisticsDialog() > 0 then
       warnlog "Something went wrong trying to invoke Statistics dialog -> Check this out!"
       Call hCloseDocument
       goto endsub
   endif
   '///+<li>Check 'Constant Value' to enable all controls</li>
   if fSetErrorCategory ( ConstantValue ) > 0 then
       warnlog "Something went wrong trying to check 'Constant Value' -> Check this out!"
   endif   
   '///+<li>Check existence of dialog</li>
   Kontext "InsertStatisticsDialog"
   Call DialogTest ( InsertStatisticsDialog )
   '///+<li>Quit dialog using Cancel button</li>
   InsertStatisticsDialog.Cancel
   Kontext "DocumentCalc"
   DocumentCalc.TypeKeys "<Escape>"
   '///<li>Close document</li>///
   Call hCloseDocument

endcase
'-------------------------------------------------------------
testcase tInsertSpecialCharacter
   qaErrorLog "#125905# - Insert / SpecialCharacter doesn't work corrcetly in title dialog."   
endcase

