@echo off
rem ***********************************************************************
rem
rem  OpenOffice.org - a multi-platform office productivity suite
rem
rem  $RCSfile: ooo_screenshots.bat,v $
rem
rem  $Revision: 1.1 $
rem
rem  last change: $Author: tbo $ $Date: 2007/01/10 15:20:53 $
rem
rem  The Contents of this file are made available subject to
rem  the terms of GNU Lesser General Public License Version 2.1.
rem
rem
rem    GNU Lesser General Public License Version 2.1
rem    =============================================
rem    Copyright 2005 by Sun Microsystems, Inc.
rem    901 San Antonio Road, Palo Alto, CA 94303, USA
rem
rem    This library is free software; you can redistribute it and/or
rem    modify it under the terms of the GNU Lesser General Public
rem    License version 2.1, as published by the Free Software Foundation.
rem
rem    This library is distributed in the hope that it will be useful,
rem    but WITHOUT ANY WARRANTY; without even the implied warranty of
rem    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
rem    Lesser General Public License for more details.
rem
rem    You should have received a copy of the GNU Lesser General Public
rem    License along with this library; if not, write to the Free Software
rem    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
rem    MA  02111-1307  USA
rem
rem ########################################################################
rem
rem Owner : petr.dudacek@sun.com
rem
rem short description : create ~750 screenshots of dialogs
rem
rem note: in order to create screenshots, add the generic
rem       TestTool configuration item: Screenshot
rem       
rem        values:
rem         True / 1 : Enable screenshots
rem         False / 0 : Disable screenshots
rem
rem
rem more info at: http://qa.openoffice.org/files/documents/77/3247/essen2006testtool2.pdf
rem
rem ########################################################################

rem if program 'tskill' is not available on your system:
rem 
rem 1. it doesn't matter; the batch works well without it.
rem 2. if you still need it, take it from:
rem 
rem http://www.pcwelt.de/public/kill.exe
rem 
rem (if the link doesn't work anymore please tell issuezilla)
rem 
rem 3. change the following lines from
rem       tskill soffice
rem    to
rem       kill /f soffice.exe

echo on

rem set location of TestTool
rem (full path including executable 'testtool')
set tool=C:\qatesttool\win32\testtool

rem set path to directory which contains directory 'qatesttool'
set work=C:

%tool% -run %work%\qatesttool\writer\update\w_updt.bas
%tool% -run %work%\qatesttool\global\tools\closeoffice.bas
tskill soffice
%tool% -run %work%\qatesttool\calc\update\c_updt.bas
%tool% -run %work%\qatesttool\global\tools\closeoffice.bas
tskill soffice
%tool% -run %work%\qatesttool\graphics\update\d_updt.bas
%tool% -run %work%\qatesttool\global\tools\closeoffice.bas
tskill soffice
%tool% -run %work%\qatesttool\graphics\update\i_updt_1.bas
%tool% -run %work%\qatesttool\global\tools\closeoffice.bas
tskill soffice
%tool% -run %work%\qatesttool\graphics\update\i_updt_2.bas
%tool% -run %work%\qatesttool\global\tools\closeoffice.bas
tskill soffice
%tool% -run %work%\qatesttool\base\update\b_updt.bas
%tool% -run %work%\qatesttool\global\tools\closeoffice.bas
tskill soffice
%tool% -run %work%\qatesttool\math\update\m_updt.bas
%tool% -run %work%\qatesttool\global\tools\closeoffice.bas
tskill soffice
%tool% -run %work%\qatesttool\framework\update\f_updt_help.bas
%tool% -run %work%\qatesttool\global\tools\closeoffice.bas
tskill soffice
%tool% -run %work%\qatesttool\framework\update\f_updt_templates.bas
%tool% -run %work%\qatesttool\global\tools\closeoffice.bas
tskill soffice
%tool% -run %work%\qatesttool\framework\update\f_updt_toolbars.bas
%tool% -run %work%\qatesttool\global\tools\closeoffice.bas
tskill soffice
%tool% -run %work%\qatesttool\framework\update\f_updt_spadmin.bas
%tool% -run %work%\qatesttool\global\tools\closeoffice.bas
tskill soffice
%tool% -run %work%\qatesttool\framework\update\f_updt_faxwizard.bas
%tool% -run %work%\qatesttool\global\tools\closeoffice.bas
tskill soffice
%tool% -run %work%\qatesttool\framework\update\f_updt_letterwizard.bas
%tool% -run %work%\qatesttool\global\tools\closeoffice.bas
tskill soffice
%tool% -run %work%\qatesttool\framework\update\f_updt_firsttimewizard.bas
%tool% -run %work%\qatesttool\global\tools\closeoffice.bas
tskill soffice
%tool% -run %work%\qatesttool\framework\update\f_updt_agendawizard.bas
%tool% -run %work%\qatesttool\global\tools\closeoffice.bas
tskill soffice
%tool% -run %work%\qatesttool\framework\update\f_updt_basic.bas
%tool% -run %work%\qatesttool\global\tools\closeoffice.bas
tskill soffice
%tool% -run %work%\qatesttool\framework\update\f_updt_basicorganizer.bas
%tool% -run %work%\qatesttool\global\tools\closeoffice.bas
tskill soffice
%tool% -run %work%\qatesttool\framework\update\f_updt_presentationwizard.bas
%tool% -run %work%\qatesttool\global\tools\closeoffice.bas
tskill soffice
%tool% -run %work%\qatesttool\framework\update\f_updt_documentconverter.bas
%tool% -run %work%\qatesttool\global\tools\closeoffice.bas
tskill soffice
%tool% -run %work%\qatesttool\framework\update\f_updt_euroconverter.bas
%tool% -run %work%\qatesttool\global\tools\closeoffice.bas
tskill soffice
%tool% -run %work%\qatesttool\framework\update\f_updt_wizard_webpage.bas
%tool% -run %work%\qatesttool\global\tools\closeoffice.bas
tskill soffice
%tool% -run %work%\qatesttool\framework\update\f_updt_scriptnames.bas
%tool% -run %work%\qatesttool\global\tools\closeoffice.bas
tskill soffice
%tool% -run %work%\qatesttool\framework\update\f_updt_autotext.bas
%tool% -run %work%\qatesttool\global\tools\closeoffice.bas
tskill soffice
%tool% -run %work%\qatesttool\framework\update\f_updt_customize.bas
%tool% -run %work%\qatesttool\global\tools\closeoffice.bas
tskill soffice
%tool% -run %work%\qatesttool\framework\update\f_updt_optionitems.bas
%tool% -run %work%\qatesttool\global\tools\closeoffice.bas
tskill soffice
%tool% -run %work%\qatesttool\framework\update\f_updt_windowfuncs.bas
%tool% -run %work%\qatesttool\global\tools\closeoffice.bas
tskill soffice
%tool% -run %work%\qatesttool\framework\update\f_updt_pkgmgr.bas
%tool% -run %work%\qatesttool\global\tools\closeoffice.bas
tskill soffice
